'sGUI
#include "sGUI\sGUI.bas"
#include once "sGUI\SimpleGadget.bas"
#include once "sGUI\StringGadget.bas"
#include once "sGUI\ScrollBar.bas"
#include once "sGUI\Arrows.bas"
#include once "sGUI\MultiLineEditBox.bas"
#include once "sGUI\MessageBox.bas"
#include once "sGUI\ClickMapGadget.bas"
#include once "sGUI\Menu.bas"
using sGUI

'Netzwerk TSNE
#include "Network\eazyTSNE.bas"

'Pseudo EingabeBoxen, bentigen sGUI und Netzwerkzeugs
#include "Requests\GameModeRequest.bas"
#include "Requests\IPPortRequest.bas"
#include "Requests\PortRequest.bas"

'das eigentliche Spiel, also der Regelwchter
#include "GameIncludes\Game.bi"

'Grafiken
#include "GameIncludes\GFXStuff.bas"

screenres 580,550,32,,&H04
width 560\8,550\16

'GUI Vorbereitungen************************************************************
CustomColors=1
BackGroundColor         =&H9080AD
TextColor               =black
GadgetColor			        =&HFF9E3F
GadgetSelectedColor     =&HFFAA00
InnerGadgetCaptionColor =black
OuterGadgetCaptionColor =black
SymbolColor             =black
EditTextColor           =black
EditBackGroundColor     =&HF4F4F4
EditCursorColor         =&H337FFF
MenuColor               =BackGroundColor
MenuTextColor           =&HFFFF00
MenuGhostedColor        =ShiftRGB (MenuColor,-contrast/2)
InitGFX

'Spiel erzeugen****************************************************************
dim as Bebalone Game

dim as integer gamemode

dim as integer mycolor,oppcolor,myActionCounter,oppActionCounter
dim as string myname,myGameString,oppname,oppGameString

dim as string MsgIn,StartTag

dim as integer sendsync,syncdelay,nextsynctime
sendsync=0
syncdelay=5

dim as string ScreenTitle
ScreenTitle="Bebalone V0.39      "


'Alle Grafiken Laden und Hintergrund setzen************************************
dim as any ptr g(5)
GFXLoader (g())
dim as HollowOffset h(1 to 61)'OffsetTabelle fr die Grafik des Spielfeldes
SetHOffsets(h())'Initiieren dieser Offsets
bload "gfx\background.bmp",0

'Credits***********************************************************************
'in diesem Fall die MessageBox ber den Namespace aufrufen, da sonst Kollision mit der windowseigenen Variante
sGUI.MessageBox(10,30,"Vielen Dank an ThePuppetMaster|fuer seine TSNE Bibliothek, sowie|MOD fuer seine Beispiele, wie man selbige|Bibliothek nutzen kann.","Credits",1)

'SpielModus abfragen***********************************************************
gamemode=GameModeRequest (100,150)'0=offline 1=Server 2=Client


'Netzwerkzeugs*****************************************************************
dim as integer CS,oCS'Hilfsvariablen um auf eine Verbindungsstatusnderung zu reagieren
oCS=0

'Bildschirm aufbauen***********************************************************
ShowPlayField (5,30,Game , h(), g() )
'put (347,128),g(4),trans' BMP mit den Pfeilen fr die Kugelverschiebung
ShowInfo (347,128,Game , h(), g() )

'EventHandle fr GUI erzeugen *************************************************
dim as EventHandle ptr event
event=CreateEventHandle

'Gadgets erzeugen**************************************************************
dim as Gadget ptr playfield,arrows,msglog,msginput,msgsend
playfield=AddClickMapGadget(event,5,30,"gfx\clickmappf.bmp")
arrows   =AddClickMapGadget(event,347,128,"gfx\clickmapar.bmp")
GadgetSleep(playfield)
GadgetSleep(arrows)

msglog=AddMultiLineEditBox (event,20,320,65,10,0)
TO_SetLineContent(msglog,1,"***** Willkommen zu Bebalone *****")
UpdateGadget(msglog)
GadgetOn(msglog)

msginput=AddStringGadget(event,20,510,56,"",,,1)
msgsend=AddSimpleGadget(event,491,511,70,20,"Sende")
GadgetSleep(msginput,msgsend)

'fr den jeweiligen Spielmodus sind Mens,Variablen unterschiedlich
select case gamemode
	case 0
    windowtitle ScreenTitle & "Offline"

    Menu (event,1,0,1,"Programm")
    Menu (event,1,1,1,"Beenden")

    Menu (event,2,0,1,"Spiel")
    Menu (event,2,1,1,"Starten")
    Menu (event,2,2,0,"Abbruch")
  case 1
    windowtitle ScreenTitle & "Server"

    TO_AppendLine (msglog,"Suche nach IP... bitte warten")
    UpdateGadget (msglog)
    TO_AppendLine (msglog,"IP: " & AskDYNDNS)
    TO_AppendLine (msglog,"Bei Fehlschlag bitte die eigene IP ueber")
    TO_AppendLine (msglog,"entsprechende Seiten im Webbrowser ermitteln")
    TO_AppendLine (msglog,"zB.: wieistmeineip.de , dyndns.org")
    TO_AppendLine (msglog,"Diese IP und der gegebenenfalls geaenderte Port")
    TO_AppendLine (msglog,"ist dem Client zu uebermitteln,")
    TO_AppendLine (msglog,"damit dieser eine Verbindung herstellen kann!")
    UpdateGadget (msglog)

    Menu (event,1,0,1,"Programm")
    Menu (event,1,1,1,"Starte Server")
    Menu (event,1,2,1,"Beenden")

    Menu (event,2,0,0,"Spiel")
    Menu (event,2,1,0,"Abbruch")

    myname="Server"
    oppname="Client"

  case 2
    windowtitle ScreenTitle & "Client"

    Menu (event,1,0,1,"Programm")
    Menu (event,1,1,1,"Starte Client")
    Menu (event,1,2,1,"Beenden")


    Menu (event,2,0,0,"Spiel")' wenn noch keine Verbindung, Men nicht anwhlbar
    Menu (event,2,1,1,"Client=Schwarz vs. Server=Weiss")
    Menu (event,2,2,1,"Server=Schwarz vs. Client=Weiss")
    Menu (event,2,3,0,"Abbruch")

   myname="Client"
   oppname="Server"
end select

MenuOn (event)



'******************************************************************************
'******************************************************************************
'Eventloop*********************************************************************
do
  event->xSleep(0)'0=nicht warten, da das "Netzwerk" permanent berprft wird

  select case gamemode
'Offline Game******************************************************************
    case 0
      if event->GADGETMESSAGE then                            'Gadget Events
        select case event->GADGETMESSAGE
          case arrows                                        	'Zug in gewnscht Richtung machen / Regelberprfung /Spielerwechsel
            if Game.MoveBalls(GetClickMapColor(arrows)) then 	'Game
              ShowPlayField (5,30,game,h(),g())               'Grafik
              ShowInfo (347,128,game,h(),g())
            end if
            if game.GetOutBlack=6 or game.GetOutWhite=6 then 	'wenn 6 Kugeln einer Farbe draussen sind,ist das Spiel zu Ende
              GadgetSleep(playfield)                          'einzig die GUI weiss davon noch nichts, wird jetzt nachgeholt
              GadgetSleep(arrows)                             'schalte die Gadgets in den Sleep Modus
              Menu (event,2,1,1,"Start")                     	'Men anpassen "Spiel starten" wieder aktiv
              Menu (event,2,2,0,"Abbruch")
            end if
          case playfield                                     	'Selektion der Kugeln
            Game.PlayFieldClick(GetClickMapColor(playfield))  'Game
            ShowPlayField (5,30,game,h(),g())                 'Grafik
        end select
      end if

    	if event->MENUMESSAGE then                            'Men Events
    		select case event->MENUNUMBER
    			case 1                                            'Programm Men
    				select case event->ITEMNUMBER
    					case 1                     										'Ende des Programms einleiten
                event->EXITEVENT=1
    				end select
    			case 2                                            'Offline Spiel Men
    				select case event->ITEMNUMBER
    					case 1                              					'Spielstart
    						Game.StartGame                              'Game
    						ShowPlayField (5,30,game,h(),g())           'Grafik
              	ShowInfo (347,128,game,h(),g())
    						GadgetOn(playfield)                         'GUI
    						GadgetOn(arrows)
    						Menu (event,2,1,0,"Start")
    						Menu (event,2,2,1,"Abbruch")
    					case 2                              					'Spielabbruch
    						Game.StopGame                               'Game
    						ShowInfo (347,128,game,h(),g())             'Grafik
    						GadgetSleep(playfield)                      'GUI
    						GadgetSleep(arrows)
    						Menu (event,2,1,1,"Start")
    						Menu (event,2,2,0,"Abbruch")
            end select
    		end select
    	end if


'******************************************************************************
'******************************************************************************
'******************************************************************************

'Online Game Server/Client*****************************************************
    case is >0
      if event->GADGETMESSAGE then                            'Gadget Events
        select case event->GADGETMESSAGE
          case arrows                                        	'Zug in gewnscht Richtung machen / Regelberprfung /Spielerwechsel
            if mycolor=game.GetGame then
              if Game.MoveBalls(GetClickMapColor(arrows)) then 	'Game
                ShowPlayField (5,30,game,h(),g())               'Grafik
                ShowInfo (347,128,game,h(),g())
                SN.SendMessage("[MOV]" & Game.GetGameString)
                sendsync=1
                nextsynctime=timer+syncdelay
              end if
            end if
            if game.GetOutBlack=6 or game.GetOutWhite=6 then 	'wenn 6 Kugeln einer Farbe draussen sind,ist das Spiel zu Ende
              GadgetSleep(playfield)                          'einzig die GUI weiss davon noch nichts, wird jetzt nachgeholt
              GadgetSleep(arrows)                             'schalte die Gadgets in den Sleep Modus
              if myname="Server" then
                Menu (event,2,1,0,"Abbruch")
              else      'Client
                Menu (event,2,1,1,"Client=Schwarz vs. Server=Weiss")
                Menu (event,2,2,1,"Server=Schwarz vs. Client=Weiss")
                Menu (event,2,3,0,"Abbruch")
              end if
              SN.SendMessage("[BRK]")
            end if

          case playfield                                     	'Selektion der Kugeln
            if mycolor=game.GetGame then
              if Game.PlayFieldClick(GetClickMapColor(playfield)) then      'Game
                ShowPlayField (5,30,game,h(),g())                           'Grafik
                SN.SendMessage("[SEL]" & Game.GetGameString)
              end if
            end if

          case msginput,msgsend
            if len(GetString(msginput)) then
              SN.SendMessage("[TXT]" & GetString(msginput))
              TO_AppendLine (msglog,myname & "> " & GetString(msginput))
              TO_SetCursorToLastLine (msglog)
              UpdateGadget (msglog)
              SetString(msginput,"")
            end if

        end select
      end if

    	if event->MENUMESSAGE then                            'Men Events
    		select case event->MENUNUMBER
    			case 1                                            'Programm Men
    				select case event->ITEMNUMBER
    					case 1
                if myname="Server" then                           'Server
                  PortRequest (40,100)
                  if SN.CreateServer then Menu (event,1,1,0,"Starte Server")
                else                                              'Client
                  IPPortRequest (40,100)
                  if SN.CreateClient then
                    GadgetOn(msginput)
                    GadgetOn(msgsend)
                    Menu (event,1,1,0,"Starte Client")
                    Menu (event,2,0,1,"Spiel")
                  end if
                end if

              case 2
                event->EXITEVENT=1
    				end select

          case 2
      			if myname="Server" then                           'Spiel Men Server
            	select case event->ITEMNUMBER
      					case 1
                  Game.StopGame
      						ShowInfo (347,128,game,h(),g())
      						GadgetSleep(playfield)
      						GadgetSleep(arrows)
                  Menu (event,2,1,0,"Abbruch")
                  SN.SendMessage("[BRK]")
                  TO_AppendLine (msglog,myname & " bricht Spiel ab")
                  TO_SetCursorToLastLine (msglog)
                  UpdateGadget (msglog)
              end select
            else                                              'Spiel Menu Client
              select case event->ITEMNUMBER

      					case 1
      						Game.StartGame                              'Game
      						ShowPlayField (5,30,game,h(),g())           'Grafik
                	ShowInfo (347,128,game,h(),g())
      						GadgetOn(playfield)                         'GUI
      						GadgetOn(arrows)
                  Menu (event,2,1,0,"Client=Schwarz vs. Server=Weiss")
                  Menu (event,2,2,0,"Server=Schwarz vs. Client=Weiss")
                  Menu (event,2,3,1,"Abbruch")
                  SN.SendMessage("[GAM]"& chr(1))
                  TO_AppendLine (msglog,"Spielstart: Client=Schwarz vs. Server=Weiss")
                  TO_SetCursorToLastLine (msglog)
                  UpdateGadget (msglog)
      					  mycolor=1

                case 2
      						Game.StartGame                              'Game
      						ShowPlayField (5,30,game,h(),g())           'Grafik
                	ShowInfo (347,128,game,h(),g())
      						GadgetOn(playfield)                         'GUI
      						GadgetOn(arrows)
                  Menu (event,2,1,0,"Client=Schwarz vs. Server=Weiss")
                  Menu (event,2,2,0,"Server=Schwarz vs. Client=Weiss")
                  Menu (event,2,3,1,"Abbruch")
                  SN.SendMessage("[GAM]"& chr(2))
                  TO_AppendLine (msglog,"Spielstart: Server=Schwarz vs. Client=Weiss")
                  TO_SetCursorToLastLine (msglog)
                  UpdateGadget (msglog)
                  mycolor=2

                case 3
                  Game.StopGame                               'Game
      						ShowInfo (347,128,game,h(),g())             'Grafik
      						GadgetSleep(playfield)                      'GUI
      						GadgetSleep(arrows)
                  Menu (event,2,1,1,"Client=Schwarz vs. Server=Weiss")
                  Menu (event,2,2,1,"Server=Schwarz vs. Client=Weiss")
                  Menu (event,2,3,0,"Abbruch")
                  SN.SendMessage("[BRK]")
                  TO_AppendLine (msglog,myname & " bricht Spiel ab")
                  TO_SetCursorToLastLine (msglog)
                  UpdateGadget (msglog)

              end select
            end if
    		end select
    	end if

    'Verbindungsstatus prfen
    'wenn sich etwas verndert hat, entsprechende Aktionen
    CS=SN.GetConnectionStatus
    if CS>oCS then            'einmalige Aktion bei Verbindungsaufbau
      GadgetOn(msginput)
      GadgetOn(msgsend)
      Menu (event,2,0,1,"Spiel")
    elseif CS<oCS  then     'einmalige Action bei Verbindungsabbruch
      GadgetSleep(msginput)
      GadgetSleep(msgsend)
      GadgetSleep(playfield)
      GadgetSleep(arrows)
      Menu (event,2,0,0,"Spiel")
    end if
    oCS=CS

        'eingehende Messages vom Server/Client
    if SN.MessagePing then
      PullUpMenu(event) 'offenes Men schlieen,ist Brechstangenprinzip und nachtrglich in sGUI eingefgt worden... egal ;)

      MsgIn=SN.GetMessage
      StartTag=left(MsgIn,5)
      MsgIn=mid(MsgIn,6,len(MsgIn)-10)

      select case StartTag
        case "[SEL]"
          sendsync=0
          oppGameString=MsgIn
          Game.SetGameString(oppGameString)
          ShowPlayField (5,30,game,h(),g())
          ShowInfo (347,128,game,h(),g())


        case "[MOV]"
          oppGameString=MsgIn
          Game.SetGameString(oppGameString)
          ShowPlayField (5,30,game,h(),g())
          ShowInfo (347,128,game,h(),g())
          TO_AppendLine (msglog,myname &" ist am Zug")
          TO_SetCursorToLastLine (msglog)
          UpdateGadget (msglog)


        case "[SNC]"
          oppGameString=MsgIn
          oppActionCounter=cvi(right(oppGameString,4))
          if oppActionCounter>Game.GetActionCounter then
            Game.SetGameString(oppGameString)
            ShowPlayField (5,30,game,h(),g())
            ShowInfo (347,128,game,h(),g())
            TO_AppendLine (msglog,"uebertragene Daten gingen verloren, Sychronisation erfolgreich")
            TO_AppendLine (msglog,myname &" ist am Zug")
            TO_SetCursorToLastLine (msglog)
            UpdateGadget (msglog)
          end if

        case "[TXT]"
          TO_AppendLine (msglog,oppname & "> "& MsgIn)
          TO_SetCursorToLastLine (msglog)
          UpdateGadget (msglog)

        case "[GAM]"
          if MsgIn[0]=1 then
  						Game.StartGame
  						ShowPlayField (5,30,game,h(),g())
          	ShowInfo (347,128,game,h(),g())
  						GadgetOn(playfield)
  						GadgetOn(arrows)
            Menu (event,2,1,1,"Abbruch")
            TO_AppendLine (msglog,"Spielstart: Client=Schwarz vs. Server=Weiss")
            TO_SetCursorToLastLine (msglog)
            UpdateGadget (msglog)
            mycolor=2
          end if
          if MsgIn[0]=2 then
  						Game.StartGame
  						ShowPlayField (5,30,game,h(),g())
          	ShowInfo (347,128,game,h(),g())
  						GadgetOn(playfield)
  						GadgetOn(arrows)
            Menu (event,2,1,1,"Abbruch")
            TO_AppendLine (msglog,"Spielstart: Server=Schwarz vs. Client=Weiss")
            TO_SetCursorToLastLine (msglog)
            UpdateGadget (msglog)
            mycolor=1
          end if

        case "[BRK]"
          sendsync=0
          Game.StopGame
  						ShowInfo (347,128,game,h(),g())
  						GadgetSleep(playfield)
  						GadgetSleep(arrows)
          if myname="Server" then
            Menu (event,2,1,0,"Abbruch")
          else'myname="Client"
            Menu (event,2,1,1,"Client=Schwarz vs. Server=Weiss")
            Menu (event,2,2,1,"Server=Schwarz vs. Client=Weiss")
            Menu (event,2,3,0,"Abbruch")
          end if
          TO_AppendLine (msglog,oppname & " bricht Spiel ab")
          TO_SetCursorToLastLine (msglog)
          UpdateGadget (msglog)
        end select
    end if

    if sendsync then                                          'Synchronisation bei Datenverlust
      if nextsynctime<=timer then
        SN.SendMessage("[SNC]" & Game.GetGameString)
        nextsynctime=timer+syncdelay
        'TO_AppendLine (msglog,"Sende Synchronisationsdaten")
        'TO_SetCursorToLastLine (msglog)
        'UpdateGadget (msglog)
      end if
    end if

    if SN.StatusTextPing then                                 'Messages vom Netzwerkmodul
      TO_AppendLine (msglog,SN.GetStatusText)
      TO_SetCursorToLastLine (msglog)
      UpdateGadget (msglog)
    end if

  end select

  if Game.MessagePing then                                  'Messages durch "Gameengine"
    TO_AppendLine (msglog,Game.GetMessage)
    TO_SetCursorToLastLine (msglog)
    UpdateGadget (msglog)
  end if

loop until event->EXITEVENT
'Ende Eventloop****************************************************************
'******************************************************************************
'******************************************************************************

'Aufrumen*********************************************************************
DestroyEventHandle (event)'EventHandle/GUI lschen
GFXDestroyer (g())'alle Grafiken lschen
'Netzwerk zerstrt sich durch Destructor selbst

end
