type HollowOffset
	x as integer
	y as integer
end type



declare function BMPLoader (s as string) as any ptr
declare sub GFXLoader(ga() as any ptr)
declare sub GFXDestroyer(ga() as any ptr)
declare sub SetHOffsets (ha() as HollowOffset)
declare sub ShowPlayField (xpos as integer,ypos as integer, game as bebalone, ho() as HollowOffset, g() as any ptr)
declare sub ShowInfo (xpos as integer,ypos as integer,game as bebalone, ho() as HollowOffset, g() as any ptr)



function BMPLoader (s as string) as any ptr
	dim as integer w,h,ff=freefile
	dim as any ptr tmpimg
	open s for binary as #ff
		get #ff, 19,w
		get #ff, 23,h
	close #ff

	tmpimg=imagecreate(w,h)
	bload s,tmpimg

	function=tmpimg
end function



sub GFXLoader(ga() as any ptr)
'	bload "gfx\background.bmp",0
	ga(0)=BMPLoader("gfx\hollow.bmp")
	ga(1)=BMPLoader("gfx\ballblack.bmp")
	ga(2)=BMPLoader("gfx\ballwhite.bmp")
	ga(3)=BMPLoader("gfx\select.bmp")
  ga(4)=BMPLoader("gfx\arrows.bmp")
	ga(5)=BMPLoader("gfx\skull.bmp")
end sub



sub GFXDestroyer(ga() as any ptr)
	for i as integer=0 to ubound(ga)
		if ga(i) then imagedestroy ga(i)
	next i
end sub



sub ShowPlayField (xpos as integer,ypos as integer, game as bebalone, ho() as HollowOffset, g() as any ptr)
	dim as integer ii
	screenlock
		for i as integer=1 to 61
    	select case game.GetBallColor(i)
    		case 0
    			put(xpos+ho(i).x,ypos+ho(i).y ), g(0),trans
				case 1
    		  put(xpos+ho(i).x,ypos+ho(i).y ), g(1),trans
				case 2
					put(xpos+ho(i).x,ypos+ho(i).y ), g(2),trans
    	end select
      if game.GetSelection(i) then put(xpos+ho(i).x,ypos+ho(i).y ), g(3),trans
		next i
	screenunlock
end sub



sub ShowInfo (xpos as integer,ypos as integer,game as bebalone, ho() as HollowOffset, g() as any ptr)
	dim as integer x,y,oxb,oxw,oy
	screenlock
    put (xpos,ypos),g(4),trans
    select case game.GetGame
    		case 0
    			put(xpos+33,ypos+26), g(0),trans
				case 1
    		  put(xpos+33,ypos+26), g(1),trans
				case 2
					put(xpos+33,ypos+26), g(2),trans
    	end select

      oxb=153
      oxw=188
    	oy=-98
      for i as integer = 0 to 5
    		if (game.GetOutBlack-1) >= i then
        	put(xpos+oxb,ypos+oy+35*i), g(1),trans
				else
          put(xpos+oxb,ypos+oy+35*i), g(0),trans
				end if

    		if (game.GetOutWhite-1) >= i then
        	put(xpos+oxw,ypos+oy+35*i), g(2),trans
				else
          put(xpos+oxw,ypos+oy+35*i), g(0),trans
				end if
				
				if game.GetOutBlack = 6 then put(xpos+oxb,ypos+oy+35*i), g(5),trans
				if game.GetOutWhite = 6 then put(xpos+oxw,ypos+oy+35*i), g(5),trans

			next i
	screenunlock
end sub



sub SetHOffsets (ha() as HollowOffset)
		'Reihe 1:      1 - 5						o o o o o
		'Reihe 2:     6  - 11          o o o o o o
		'Reihe 3:    12  -  18        + + o o o + +
		'Reihe 4:   19   -   26      + + + + + + + +
		'Reihe 5:  27    -    35    + + + + + + + + +
		'Reihe 6:   36   -   43      + + + + + + + +
		'Reihe 7:    44  -  50        + + o o o + +
		'Reihe 8:     51 - 56          o o o o o o
		'Reihe 9:      57-61            o o o o o
	dim as integer i,radius,xspace,yspace,xo,yo,ix,iy,p
	radius=17

	xspace=radius*2+3
	yspace=radius*1.8

	ix=xspace*9-2
	iy=yspace*8 + 2*radius+1


	'Reihe 1:
	xo=(radius+2)*4
	yo=0
	p=1
	for i=0 to 4
		ha(p+i).x=xo+xspace*i
    ha(p+i).y=yo
	next i

	'Reihe 2:
	xo=(radius+2)*3
	yo +=yspace
	p=6
	for i=0 to 5
		ha(p+i).x=xo+xspace*i
    ha(p+i).y=yo
	next i

	'Reihe 3:
	xo=(radius+2)*2
	yo +=yspace
	p=12
	for i=0 to 6
		ha(p+i).x=xo+xspace*i
    ha(p+i).y=yo
	next i

	'Reihe 4:
	xo=(radius+2)*1
	yo +=yspace
	p=19
	for i=0 to 7
		ha(p+i).x=xo+xspace*i
    ha(p+i).y=yo
	next i

	'Reihe 5:
	xo=(radius+2)*0
	yo +=yspace
	p=27
	for i=0 to 8
		ha(p+i).x=xo+xspace*i
    ha(p+i).y=yo
	next i

	'Reihe 6:
	xo=(radius+2)*1
	yo +=yspace
	p=36
	for i=0 to 7
		ha(p+i).x=xo+xspace*i
    ha(p+i).y=yo
	next i

	'Reihe 7:
	xo=(radius+2)*2
	yo +=yspace
	p=44
	for i=0 to 6
		ha(p+i).x=xo+xspace*i
    ha(p+i).y=yo
	next i

	'Reihe 8:
	xo=(radius+2)*3
	yo +=yspace
	p=51
	for i=0 to 5
		ha(p+i).x=xo+xspace*i
    ha(p+i).y=yo
	next i

	'Reihe 9:
	xo=(radius+2)*4
	yo+=yspace
	p=57
	for i=0 to 4
		ha(p+i).x=xo+xspace*i
    ha(p+i).y=yo
	next i
end sub



