'Abalone Klon Game-Engine / Regelwerk
'das Spielbrett besteht aus 61 Feldern(Mulden) angeordnet im Hexagon


'Mulde UDT
'aus ihr wird spter das Spielfeld zusammengesetzt
type hollow
  private:
		ballcolor as integer'0=keine Kugel 1=schwarze Kugel 2=weisse Kugel
		sel  			as integer'"Flag" ob Mulde angewhlt ist(1) oder nicht(0)

  	'Link- und Richtungs-Array dieser Mulde
  	'enthlt die Indexnummer der anderen Mulde die sich in dieser Richtung befindet
  	'ist 0 wenn in dieser Richtung der Spielfeldrand ist
  	'Richtung 1=rechts
  	'Richtung 2=rechts unten
  	'Richtung 3=links unten
  	'Richtung 4=links
  	'Richtung 5=links oben
  	'Richtung 6=rechts oben
		link(1 to 6) as integer
	public:
		declare sub SetBallColor(b as integer)
		declare function GetBallColor()as integer

		declare sub SetSelection(s as integer)
		declare function GetSelection() as integer

		declare sub SetLink(d as integer,l as integer)
		declare function GetLink(d as integer)as integer
end type

sub hollow.SetBallColor(b as integer)
	ballcolor=b
end sub

function hollow.GetBallColor() as integer
	function=ballcolor
end function

sub hollow.SetSelection(s as integer)
	sel=s
end sub

function hollow.GetSelection() as integer
	function=sel
end function

sub hollow.SetLink (d as integer, l as integer)
	link(d)=l
end sub

function hollow.GetLink(d as integer) as integer
	function=link(d)
end function


'******************************************************************************
'******************************************************************************
'******************************************************************************

'Game UDT
type bebalone
  private:
		playfield(1 to 61) as hollow  'Spielfeld bestehend aus 61 Mulden
    game      as integer          'Spielmodus  0=kein Spiel / 1=schwarz am Zug / 2=weiss am Zug
		balls			as integer          'wieviele Kugeln sind fr den Zug ausgewhlt (max. 3), nach erfolgtem Zug wieder 0
	  store(1 to 3)	as integer	    'Ablage fr angewhlte Kugeln, Indizes der Kugeln
		target(1 to 3) as integer     'Ablage fr Verschiebung/Hinausschieben, Indizes der Kugeln
		direction   as integer        'Richtung der Reihe, wenn es denn eine ist, ansonsten=0
    outblack	as integer          'wieviele Kugeln draussen schwarz
    outwhite	as integer		      'wieviele Kugeln draussen weiss
		messagetext		as string       'Engineinterne Textmeldungen die ausgegeben werden sollen
    actioncounter as integer      'Zhlt Selektion, Deselektion, Move(erfolgreich), Move(nicht erfolgreich)

    gamestring as string            'Byte   Inhalt 74Byte
                                    '1      playfield(1).GetBallColor
                                    '61     playfield(61).GetBallColor
                                    '62     game
                                    '63     balls, Anzahl der selektierten Kugeln
                                    '64     Index selektierte Kugel
                                    '65     Index selektierte Kugel
                                    '66     Index selektierte Kugel
                                    '67     outblack
                                    '68     outwhite
                                    '69     leer
                                    '70     leer
                                    '71     mki actioncounter
                                    '72     mki actioncounter
                                    '73     mki actioncounter
                                    '74     mki actioncounter
  public:
  declare constructor ()
		declare destructor ()

		declare sub StartGame
		declare sub StopGame
		declare function PlayFieldClick(h as integer) as integer
	  declare function MoveBalls(d as integer) as integer

		declare function GetBallColor (h as integer)as integer
		declare function GetSelection (h as integer)as integer
    declare function GetGameString as string
    declare sub SetGameString(s as string)
		declare function GetActionCounter as integer
		declare function MessagePing as integer
    declare function GetMessage as string
		declare function GetGame as integer
		declare function GetOutBlack as integer
		declare function GetOutWhite as integer

	private:
		declare sub CreateGameString
    declare sub InstallGameString
    declare function CheckFreeSide(d as integer) as integer
		declare function CheckFreeHollow(h as integer,d as integer) as integer
		declare function CheckStore as integer
		declare sub ClearStore
		declare sub FlipGame
		declare sub SearchSelected
		declare sub DeselectAllHollows

		declare sub InitLinks
		declare sub InitBalls

end type



'public Methoden***************************************************************



constructor bebalone ()
	InitLinks
	game=0
	balls=0
	outblack=0
	outwhite=0
end constructor



destructor bebalone ()
end destructor



sub bebalone.StartGame
	InitBalls
	DeselectAllHollows
	game=1
	balls=0
	outblack=0
	outwhite=0
	actioncounter=0
	messagetext="Das Spiel beginnt. Schwarz ist am Zug..."
end sub



sub bebalone.StopGame
	game=0
	messagetext="Das Spiel wurde abgebrochen!"
end sub



function bebalone.GetBallColor (h as integer)as integer
	function=playfield(h).GetBallColor
end function



function bebalone.GetSelection(h as integer)as integer
	function=playfield(h).GetSelection
end function


function bebalone.GetGameString as string
  CreateGameString
  function=gamestring
end function


sub bebalone.SetGameString(s as string)
  gamestring=s
  InstallGameString
end sub


function bebalone.GetActionCounter as integer
  function=actioncounter
end function

function bebalone.GetGame as integer
	function=game
end function



function bebalone.GetOutBlack as integer
	function=outblack
end function



function bebalone.GetOutWhite as integer
	function=outwhite
end function



function bebalone.MessagePing as integer
	function=0
	if messagetext<>"" then function=1
end function



function bebalone.GetMessage as string
	function=messagetext
	messagetext=""
end function



function bebalone.PlayFieldClick(h as integer) as integer
	function=0
  if playfield(h).GetBallColor=game  then  'hat der Spieler seine eigene Kugel angeklickt, wenn ja dann...
		if playfield(h).GetSelection=0 then    'ist diese Kugel noch nicht selektiert, wenn ja dann...
			if balls<3 then                      'sind noch weniger als 3 Kugeln selektiert, wenn ja dann
				balls +=1
      	playfield(h).SetSelection(1)
    	end if
		else                                   'sollte die Kugel doch schon selektiert sein
			balls -=1
      playfield(h).SetSelection(0)         'Aufheben der Selektion
    end if
    actioncounter +=1
    function=1
  end if
end function



function bebalone.MoveBalls(d as integer) as integer
'btw ein verdammt bles Entscheidungs-Konstrukt
'sollte aber alle Bewegungs- und Schieberegeln abdecken
	function=0
	dim as integer front,back,opponent
	if game=1 then opponent=2
	if game=2 then opponent=1
	if balls then
		SearchSelected                                      'hole alle Indizes der selektierten Kugel(n) in den Indexspeicher
																												'(lassen sich dort besser berprfen)
		select case balls
			case 1                                            'bei einer selektierte Kugel
				if CheckFreeHollow(store(1),d) then             'wenn Mulde in Zugrichtung frei (CheckFreeHollow gibt nur ja/nein aus)
    			target(1)=playfield(store(1)).GetLink(d)         'Zielindex holen
	        playfield(target(1)).SetBallColor(game)          'Zielindex in Spielerfarbe "einfrben"
					playfield(store(1)).SetBallColor(0)           'Ausgangsindex auf 0 setzen, also keine Kugel mehr dort vorhanden

					DeselectAllHollows                            'alle Selektierungen im Spielfeld aufheben
	        ClearStore                                    'Indexspeicher leeren
          FlipGame                                      'Spielerwechsel und messagetext absetzen
					function=1                                    'Zug erfolgreich nach "aussen" melden

				else                                            'sollte Zugrichtung nicht frei sein
    			messagetext="Feld nicht frei, Spielfeldrand"  'messagetext absetzen
				end if

	 case 2,3                                              'bei mehr als einer selektierten Kugel
				if CheckStore then                               'berprfe ob alle Kugeln eine Reihe ergeben, wenn ja dann
					if d>3 then direction +=3                      'wenn die Zugrichtung links / links-oben / oben ist, dann Richtung der Kugelreihe umdrehen
					if d=direction then                            'wenn Zugrichtung gleich der Richtung der Kugelreihe ist
          	front=store(1)                               'Start- und Endkugel definieren und gegebenfalls anpassen an Zugrichtung
          	back=store(balls)                            '                        ""
						if direction<4 then swap front,back          '                        "" (sind halt nur Krcken)
						if CheckFreeHollow(front,d) then             'wenn Mulde in Zugrichtung frei (CheckFreeHollow gibt nur ja/nein aus)
    					target(1)=playfield(front).GetLink(d)      'Zielindex holen
	        		playfield(target(1)).SetBallColor(game)    'Zielindex in Spielerfarbe "einfrben"
	        		playfield(back).SetBallColor(0)            'Index der Endkugel auf 0 setzen, also keine Kugel mehr dort vorhanden

							DeselectAllHollows                         'selbe Prozedur wie oben
	        		ClearStore
              FlipGame                                   'Spielerwechsel und messagetext absetzen
							function=1
						else																												'wenn Mulde nicht frei...
              target(1)=playfield(front).GetLink(d)											'1.Zielindex holen
							if target(1) then																					'wen 1.Zielindex kein Spielfeldrand
              	if playfield(target(1)).GetBallColor=opponent then			'nur wenn erstes Zielfeld vom Gegner besetzt ist
									target(2)=playfield(target(1)).GetLink(d)							'2.Zielindex holen
									if target(2) then                                     'wenn 2.Zielindex kein Spielfeldrand
										if playfield(target(2)).GetBallColor=0 then         'wenn 2.Zielindex eine freie Mulde ist
                      playfield(target(2)).SetBallColor(opponent)    		'Zielindex in Gegnerfarbe "einfrben"
											playfield(target(1)).SetBallColor(game)    				'Zielindex in Spielerfarbe "einfrben"
	        						playfield(back).SetBallColor(0)            				'Index der Endkugel auf 0 setzen, also keine Kugel mehr dort vorhanden

											DeselectAllHollows                         				'selbe Prozedur wie oben
	        						ClearStore
                      FlipGame                                          'Spielerwechsel und messagetext absetzen
											function=1
										else                                                'wenn 2.Zielindex keine freie Mulde
											if balls=2 then                                   'ist eine 2er Reihe unterwegs(natrlich als ein Fehlschlag)
												messagetext="Patt, Feld nicht frei"             'messagetext setzen
											else                                              'wenn keine 2er Reihe, also 3er Reihe
												target(3)=playfield(target(2)).GetLink(d)         '3.Zielindex holen
												if target(3) then                                 'wenn 3.Zielindex kein Spielfeldrand
                          if playfield(target(3)).GetBallColor=0 then     'wenn 3.Zielindex eine freie Mulde ist
 														playfield(target(3)).SetBallColor(opponent)    	'3.Zielindex in Gegnerfarbe "einfrben"
														playfield(target(1)).SetBallColor(game)    			'1.Zielindex in Spielerfarbe "einfrben"
				        						playfield(back).SetBallColor(0)            			'Index der Endkugel auf 0 setzen, also keine Kugel mehr dort vorhanden

														DeselectAllHollows                         'selbe Prozedur wie oben
				        						ClearStore
                            FlipGame                                   'Spielerwechsel und messagetext absetzen
														function=1
 													else
														messagetext="Patt,Feld nicht frei"'messagetext setzen
													end if
												else                                              'Wenn 3.Zielindex doch Spielfeldrand
				        					playfield(target(2)).SetBallColor(opponent)    	'2.Zielindex in Gegnerfarbe "einfrben"
													playfield(target(1)).SetBallColor(game)    			'1.Zielindex in Spielerfarbe "einfrben"
				        					playfield(back).SetBallColor(0)            			'Index der Endkugel auf 0 setzen, also keine Kugel mehr dort vorhanden

													if game=1 then outwhite +=1                			'den entsprechenden Kugel-Out-Counter erhhen
													if game=2 then outblack +=1

													DeselectAllHollows                         'selbe Prozedur wie oben
				        					ClearStore
                          FlipGame                                   'Spielerwechsel und messagetext absetzen
													function=1
												end if
											end if
										end if
									else                                         'wenn 2.Zielindex doch Spielfeldrand kann sowohl 3er als auch 2er Reihe kann jetzt eine gegnerische Kugel aus dem Spielfeld rumen
	        					playfield(target(1)).SetBallColor(game)    '1.Zielindex in Spielerfarbe "einfrben"
	        					playfield(back).SetBallColor(0)            'Index der Endkugel auf 0 setzen, also keine Kugel mehr dort vorhanden

										if game=1 then outwhite +=1                'den entsprechenden Kugel-Out-Counter erhhen
										if game=2 then outblack +=1

										DeselectAllHollows                         'selbe Prozedur wie oben
	        					ClearStore
                    FlipGame                                   'Spielerwechsel und messagetext absetzen
										function=1
									end if
								else
                  messagetext="durch eigene Kugel gesperrt!"'messagetext setzen
								end if
							else
									messagetext="Richtung ausserhalb des Spielfeldes!"'messagetext setzen
							end if
						end if
					else					                                 'wenn die Kugelreihe seitwrts bewegt wird
          	if CheckFreeSide(d) then                     'berprfung ob in Zugrichtung fr alle angewhlten Kugel eine freie Mulde da ist, wenn ja
          		for i as integer=1 to balls                'alle angewhlten Kugeln verschieben
    						target(1)=playfield(store(i)).GetLink(d)
	        			playfield(store(i)).SetBallColor(0)
	        			playfield(target(1)).SetBallColor(game)
							next i

							DeselectAllHollows                         'selbe Prozedur wie oben
	        		ClearStore
              FlipGame                                   'Spielerwechsel und messagetext absetzen
							function=1
						else                                          'sollte die Seitwrtsverschiebung nicht gehen
              messagetext="ein o. mehrere Felder besetzt in Zugrichtung,Spielfeldrand ereicht"'messagetext setzen
						end if
					end if
				else                                              'sollten die angewhlten Kugeln keine Reihe ergeben
        	ClearStore                                      'Aufrumen
					messagetext="Kugeln bilden keine Reihe!"        'messagetext setzen
				end if
		end select

	else                                                    'wenn keine Kugel(n) selektiert dann auch keine Bewegung
		messagetext="Keine Kugel(n) angewaehlt!"                  'messagetext setzen
	end if

	if outwhite=6 then
		game=0
		messagetext="!!! Schwarz hat gewonnen!!!"
	end if
	if outblack=6 then
		game=0
		messagetext="!!! Weiss hat gewonnen!!!"
	end if
	actioncounter +=1
end function



'private Methoden**************************************************************
sub bebalone.CreateGameString
'Byte   Inhalt
'1      playfield(1).GetBallColor
'61     playfield(61).GetBallColor
'62     game
'63     balls, Anzahl der selektierten Kugeln
'64     Index selektierte Kugel
'65     Index selektierte Kugel
'66     Index selektierte Kugel
'67     outblack
'68     outwhite
'69     leer
'70     leer
'+4 Byte cvi(gamestring)
  dim as integer refselball=63
  gamestring=string(70,"0")
  for i as integer=1 to 61
    gamestring[i-1]=playfield(i).GetBallColor+48
    if playfield(i).Getselection then
      gamestring[refselball]=i+48
      refselball +=1
    end if
  next i
  gamestring[61]=game+48
  gamestring[62]=balls+48
  '63-65 Indizes selektierte Blle
  gamestring[66]=outblack+48
  gamestring[67]=outwhite+48
  gamestring +=mki(actioncounter)
end sub



sub bebalone.InstallGameString
'Byte   Inhalt
'1      playfield(1).GetBallColor
'61     playfield(61).GetBallColor
'62     game
'63     balls, Anzahl der selektierten Kugeln
'64     Index selektierte Kugel
'65     Index selektierte Kugel
'66     Index selektierte Kugel
'67     outblack
'68     outwhite
'69     leer
'70     leer
'+4 Byte cvi(gamestring)
  for i as integer=1 to 61
    playfield(i).SetBallColor(gamestring[i-1]-48)
    playfield(i).SetSelection(0)
  next i
  game=gamestring[61]-48
  balls=gamestring[62]-48
  for i as integer=1 to balls
    playfield(gamestring[63+(i-1)]-48).SetSelection(1)
  next i
  outblack=gamestring[66]-48
  outwhite=gamestring[67]-48
  actioncounter=cvi(right(gamestring,4))
end sub



function bebalone.CheckFreeSide(d as integer) as integer
	function=0
	dim as integer check=0
	for i as integer=1 to balls
  	check +=CheckFreeHollow(store(i),d)
	next i
	if check=balls then function=1
end function



function bebalone.CheckFreeHollow(h as integer,d as integer) as integer
	function=0
	dim as integer l=playfield(h).GetLink(d)
	if l then
		if playfield(l).GetBallColor=0 then function=1
	end if
end function



function bebalone.CheckStore as integer
	function=0
	if balls<2 then exit function
	direction=0
	'Richtungssuche zwischen Kugel 1 und 2
	for i as integer=1 to 6
		if playfield(store(1)).GetLink(i) = store(2) then
    		direction=i
			function=-1
		end if
	next i
	'bei gefundener Richtung (wenn vorhandene) 3.Kugel berprfen
	if balls=3 and direction>0 then
		if playfield(store(2)).GetLink(direction) <> store(3) then
			direction=0
			function=0
		end if
	end if
end function



sub bebalone.ClearStore
	for i as integer=1 to 3
		store(i)=0
		target(i)=0
	next i
	direction=0
end sub



sub bebalone.FlipGame
  if game=1 then
    messagetext="Weiss ist am Zug..."
    game=2
  else
    messagetext="Schwarz ist am Zug..."
    game=1
  end if
end sub



sub bebalone.SearchSelected
	dim as integer i,count
	count=1
	for i=1 to 61
		if playfield(i).GetBallColor=game and playfield(i).GetSelection=1 then
			store(count)=i
			count +=1
		end if
	next i
end sub



sub bebalone.DeselectAllHollows
	for i as integer =1 to 61
		playfield(i).SetSelection(0)
	next i
	balls=0
end sub



sub bebalone.InitLinks
	'hier wird es jetzt so richtig bel
	'alle RichtungsLinks der Mulden mssen initiert werden.
	'es wird also nen virtuelles hexagonales Netz aufgebaut
	'in der Hoffnung das dies hier richtig erledigt wird!!!
	dim as integer i,d

	'alle Richtungen in allen Mulden auf 0 setzen
	for i=1 to 61
  	for d=0 to 5
  		playfield(i).SetLink(d,0)
  	next d
	next i


	'Richtung 1 (rechts)
	d=1
	for i=1 to 61
  	'Ausschluss aller Mulden die rechts keinen Link haben
  	'betrifft jeweils die letzten der Reihen 1 bis 9
		'Reihe 1:      1 - 5						o o o o o
		'Reihe 2:     6  - 11          o o o o o o
		'Reihe 3:    12  -  18        + + o o o + +
		'Reihe 4:   19   -   26      + + + + + + + +
		'Reihe 5:  27    -    35    + + + + + + + + +
		'Reihe 6:   36   -   43      + + + + + + + +
		'Reihe 7:    44  -  50        + + o o o + +
		'Reihe 8:     51 - 56          o o o o o o
		'Reihe 9:      57-61            o o o o o
		select case i
			case 1 to 4
        playfield(i).SetLink(d,i+1)
			case 6 to 10
      	playfield(i).SetLink(d,i+1)
			case 12 to 17
        playfield(i).SetLink(d,i+1)
      case 19 to 25
				playfield(i).SetLink(d,i+1)
			case 27 to 34
				playfield(i).SetLink(d,i+1)
			case 36 to 42
				playfield(i).SetLink(d,i+1)
			case 44 to 49
				playfield(i).SetLink(d,i+1)
			case 51 to 55
				playfield(i).SetLink(d,i+1)
			case 57 to 60
				playfield(i).SetLink(d,i+1)
		end select
	next i

	'Richtung 2 (rechts unten)
	d=2
	for i=1 to 61
  	'Ausschluss aller Mulden die rechts unten keinen Link haben
  	'betrifft Reihe 9 komplett und die jeweils letzten der Reihen 5 bis 8
    'fr jede Reihe gibt es einen neuen Summanden um den Link zur Nachbar-Mulde in dieser Richtung zu bestimmen
		'Reihe 1:      1 - 5						o o o o o
		'Reihe 2:     6  - 11          o o o o o o
		'Reihe 3:    12  -  18        + + o o o + +
		'Reihe 4:   19   -   26      + + + + + + + +
		'Reihe 5:  27    -    35    + + + + + + + + +
		'Reihe 6:   36   -   43      + + + + + + + +
		'Reihe 7:    44  -  50        + + o o o + +
		'Reihe 8:     51 - 56          o o o o o o
		'Reihe 9:      57-61            o o o o o
		select case i
			case 1 to 5
        playfield(i).SetLink(d,i+6)
			case 6 to 11
      	playfield(i).SetLink(d,i+7)
			case 12 to 18
        playfield(i).SetLink(d,i+8)
      case 19 to 26
				playfield(i).SetLink(d,i+9)
			case 27 to 34
				playfield(i).SetLink(d,i+9)
			case 36 to 42
				playfield(i).SetLink(d,i+8)
			case 44 to 49
				playfield(i).SetLink(d,i+7)
			case 51 to 55
				playfield(i).SetLink(d,i+6)
		end select
	next i

	'Richtung 3 (links unten)
	d=3
	for i=1 to 61
  	'Ausschluss aller Mulden die links unten keinen Link haben
  	'betrifft Reihe 9 komplett und die jeweils ersten der Reihen 5 bis 8
    'fr jede Reihe gibt es einen neuen Summanden um den Link zur Nachbar-Mulde in dieser Richtung zu bestimmen
		'Reihe 1:      1 - 5						o o o o o
		'Reihe 2:     6  - 11          o o o o o o
		'Reihe 3:    12  -  18        + + o o o + +
		'Reihe 4:   19   -   26      + + + + + + + +
		'Reihe 5:  27    -    35    + + + + + + + + +
		'Reihe 6:   36   -   43      + + + + + + + +
		'Reihe 7:    44  -  50        + + o o o + +
		'Reihe 8:     51 - 56          o o o o o o
		'Reihe 9:      57-61            o o o o o
		select case i
			case 1 to 5
        playfield(i).SetLink(d,i+5)
			case 6 to 11
      	playfield(i).SetLink(d,i+6)
			case 12 to 18
        playfield(i).SetLink(d,i+7)
      case 19 to 26
				playfield(i).SetLink(d,i+8)
			case 28 to 35
				playfield(i).SetLink(d,i+8)
			case 37 to 43
				playfield(i).SetLink(d,i+7)
			case 45 to 50
				playfield(i).SetLink(d,i+6)
			case 52 to 56
				playfield(i).SetLink(d,i+5)
		end select
	next i

	'Richtung 4 (links)
	d=4
	for i=1 to 61
  	'Ausschluss aller Mulden die links keinen Link haben
  	'betrifft jeweils die ersten der Reihen 1 bis 9
    'fr jede Reihe gibt es einen neuen Subtrahenden um den Link zur Nachbar-Mulde in dieser Richtung zu bestimmen  	
		'Reihe 1:      1 - 5						o o o o o
		'Reihe 2:     6  - 11          o o o o o o
		'Reihe 3:    12  -  18        + + o o o + +
		'Reihe 4:   19   -   26      + + + + + + + +
		'Reihe 5:  27    -    35    + + + + + + + + +
		'Reihe 6:   36   -   43      + + + + + + + +
		'Reihe 7:    44  -  50        + + o o o + +
		'Reihe 8:     51 - 56          o o o o o o
		'Reihe 9:      57-61            o o o o o
		select case i
			case 2 to 5
        playfield(i).SetLink(d,i-1)
			case 7 to 11
      	playfield(i).SetLink(d,i-1)
			case 13 to 18
        playfield(i).SetLink(d,i-1)
      case 20 to 26
				playfield(i).SetLink(d,i-1)
			case 28 to 35
				playfield(i).SetLink(d,i-1)
			case 37 to 43
				playfield(i).SetLink(d,i-1)
			case 45 to 50
				playfield(i).SetLink(d,i-1)
			case 52 to 56
				playfield(i).SetLink(d,i-1)
			case 58 to 61
				playfield(i).SetLink(d,i-1)
		end select
	next i
	
	'Richtung 5 (links oben)
	d=5
	for i=1 to 61
  	'Ausschluss aller Mulden die links oben keinen Link haben
  	'betrifft Reihe 1 komplett und die jeweils ersten der Reihen 2 bis 5
    'fr jede Reihe gibt es einen neuen Subtrahenden um den Link zur Nachbar-Mulde in dieser Richtung zu bestimmen
		'Reihe 1:      1 - 5						o o o o o
		'Reihe 2:     6  - 11          o o o o o o
		'Reihe 3:    12  -  18        + + o o o + +
		'Reihe 4:   19   -   26      + + + + + + + +
		'Reihe 5:  27    -    35    + + + + + + + + +
		'Reihe 6:   36   -   43      + + + + + + + +
		'Reihe 7:    44  -  50        + + o o o + +
		'Reihe 8:     51 - 56          o o o o o o
		'Reihe 9:      57-61            o o o o o

		select case i
			case 7 to 11
      	playfield(i).SetLink(d,i-6)
			case 13 to 18
        playfield(i).SetLink(d,i-7)
      case 20 to 26
				playfield(i).SetLink(d,i-8)
			case 28 to 35
				playfield(i).SetLink(d,i-9)
			case 36 to 43
				playfield(i).SetLink(d,i-9)
			case 44 to 50
				playfield(i).SetLink(d,i-8)
			case 51 to 56
				playfield(i).SetLink(d,i-7)
			case 57 to 61
				playfield(i).SetLink(d,i-6)
		end select
	next i

	'Richtung 6 (rechts oben)
	d=6
	for i=1 to 61
  	'Ausschluss aller Mulden die rechts oben keinen Link haben
  	'betrifft Reihe 1 komplett und die jeweils letzten der Reihen 2 bis 5
    'fr jede Reihe gibt es einen neuen Subtrahenden um den Link zur Nachbar-Mulde in dieser Richtung zu bestimmen
		'Reihe 1:      1 - 5						o o o o o
		'Reihe 2:     6  - 11          o o o o o o
		'Reihe 3:    12  -  18        + + o o o + +
		'Reihe 4:   19   -   26      + + + + + + + +
		'Reihe 5:  27    -    35    + + + + + + + + +
		'Reihe 6:   36   -   43      + + + + + + + +
		'Reihe 7:    44  -  50        + + o o o + +
		'Reihe 8:     51 - 56          o o o o o o
		'Reihe 9:      57-61            o o o o o
		select case i
			case 6 to 10
      	playfield(i).SetLink(d,i-5)
			case 12 to 17
        playfield(i).SetLink(d,i-6)
      case 19 to 25
				playfield(i).SetLink(d,i-7)
			case 27 to 34
				playfield(i).SetLink(d,i-8)
			case 36 to 43
				playfield(i).SetLink(d,i-8)
			case 44 to 50
				playfield(i).SetLink(d,i-7)
			case 51 to 56
				playfield(i).SetLink(d,i-6)
			case 57 to 61
				playfield(i).SetLink(d,i-5)
		end select
	next i

end sub



sub bebalone.InitBalls
	dim as integer i
		'Reihe 1:      1 - 5						2 2 2 2 2
		'Reihe 2:     6  - 11          2 2 2 2 2 2
		'Reihe 3:    12  -  18        + + 2 2 2 + +
		'Reihe 4:   19   -   26      + + + + + + + +
		'Reihe 5:  27    -    35    + + + + + + + + +
		'Reihe 6:   36   -   43      + + + + + + + +
		'Reihe 7:    44  -  50        + + 1 1 1 + +
		'Reihe 8:     51 - 56          1 1 1 1 1 1
		'Reihe 9:      57-61            1 1 1 1 1
	for i=1 to 61
		select case i
  		case 1 to 11
  			playfield(i).SetBallColor(2)
  		case 12 to 13
        playfield(i).SetBallColor(0)
      case 14 to 16
        playfield(i).SetBallColor(2)
      case 17 to 45
        playfield(i).SetBallColor(0)
			case 46 to 48
        playfield(i).SetBallColor(1)
			case 49 to 50
        playfield(i).SetBallColor(0)
      case 51 to 61
        playfield(i).SetBallColor(1)
  	end select
	next i
end sub
