#include once "TSNE_V3.bi"
'das Ermitteln der eigenen IP basiert auf dem Originalbeispiel zur TSNE Bibliothek von ThePuppetMaster:
'http://www.freebasic-portal.de/porticula/testgetwanipa-bas-1229.html
'die "Bedienkrcke" fr TSNE basiert auf MODs Beispiel:
'http://www.freebasic-portal.de/porticula/tsne-code-server-1123.html


declare sub ConnectDYNDNS  (ByVal V_TSNEID as uinteger)
declare sub ReceiveData (ByVal V_TSNEID as uinteger, ByRef V_Data as string)


dim shared as string received_Data
function AskDYNDNS as string
  function=""
  dim handle as uinteger

  dim BV as Integer
  BV = TSNE_Create_Client(handle, "checkip.dyndns.org", 80, 0, @ConnectDYNDNS, @ReceiveData, 60)
'  if BV <> TSNE_Const_NoError then
'    print "[FEHLER] " & TSNE_GetGURUCode(BV)
'    end -1
'  end if
  TSNE_WaitClose(handle)

  dim XPos as uinteger = instr(1, received_Data, "IP Address:")
  if XPos = 0 then
    function="Error"
  else
    received_Data = trim(Mid(received_Data, XPos + 11))
    XPos = instr(1, received_Data, "<")
    if XPos = 0 then
      function="Error"
    else
      function=trim(Left(received_Data, XPos - 1))
    end if
  end if
end function



sub ConnectDYNDNS(ByVal V_TSNEID as uinteger)
  dim D as string
  D = "GET / HTTP/1.0" & chr(13, 10)
  D += "Host: checkip.dyndns.org" & chr(13, 10)
  D += "User-Agent: TSNE_V3_DyndnsUpDateClient" & chr(13, 10)
  D += "connection: close" & chr(13, 10)
  D += chr(13, 10)
  dim BV as integer = TSNE_Data_Send(V_TSNEID, D)
    if BV <> TSNE_Const_NoError then
    print "[FEHLER] " & TSNE_GetGURUCode(BV)
    TSNE_Disconnect(V_TSNEID)
  end if
end sub

sub ReceiveData (ByVal V_TSNEID as uinteger, ByRef V_Data as string)
  received_Data += V_Data
end sub



'******************************************************************************
'******************************************************************************
'******************************************************************************



'subs fr TSNE-Kommunikation
declare sub TSNE_Disconnected(byval V_TSNEID as uinteger)
declare sub TSNE_Connected(byval V_TSNEID as uinteger)
declare sub TSNE_NewData(byval V_TSNEID as uinteger, byref V_Data as string)
declare sub TSNE_NewConnection(byval V_TSNEID as uinteger, byval V_RequestID as Socket, byval V_IPA as string)
declare sub TSNE_NewConnectionCanceled(byval V_TSNEID as uinteger, byval V_IPA as string)

const EndTag="[END]"'mit diesem Tag enden alle Netzwerkmessages

type SimpleNetwork
  public:
  Handle as uinteger      'TSNE Handle fr die Netzwerkverbindung
  remote as uinteger      'TSNE ID der Gegenstelle
  GuruCode as integer     'von TSNE verwalteter Fehlercode

  ServerIP  as string
  LocalHost as string
  Port      as ushort

  networkname as string

  private:
  access_VData as any ptr 'Mutex Handle fr Zugriff auf eingegangene Daten
  VData as string         'eingegangene Daten
  vDataPing as integer    '1 wenn vollstndige Nachricht (mit EndTag) eingegangen

  access_status as any ptr'Mutex Handle fr Zugriff auf Statusdaten der Netzwerkverbindung
  StatusText as string    'Statusmeldung allgemein
  connected as integer    'Verbindungsstatus 0=keine Verbindung, 1=Verbindung besteht

  public:
  declare constructor
  declare destructor

  declare sub SetStatusText (t as string)
  declare function GetStatusText as string
  declare function StatusTextPing as integer
  declare sub SetConnectionStatus (c as integer)
  declare function GetConnectionStatus as integer
  declare sub SetGuruCode (dc as integer)
  declare function GetGuruCode as integer

  declare sub SetVData (vd as string)'"Verbindung" zwischen TSNE und dem SimpleNetwork bei eingehenden Daten
  declare sub SendMessage(m as string,e as integer=1)
  declare function GetMessage as string
  declare function MessagePing as integer

  declare function CreateServer as integer
  declare function CreateClient as integer

  declare sub CloseSimpleNetwork
end type



constructor SimpleNetwork
  remote=0
  ServerIP=""
  LocalHost="127.0.0.1"
  Port=9000
  networkname="Network> "
  access_VData= mutexcreate
  access_status= mutexcreate
end constructor



destructor SimpleNetwork
  CloseSimpleNetwork
end destructor



sub SimpleNetwork.SetStatusText (t as string)
  mutexlock access_status
    StatusText &=t
  mutexunlock access_status
end sub



function SimpleNetwork.GetStatusText as string
  mutexlock access_status
    function=networkname & StatusText
    StatusText=""
  mutexunlock access_status
end function


function SimpleNetwork.StatusTextPing as integer
  function=0
  mutexlock access_status
    if StatusText <> "" then function=1
  mutexunlock access_status
end function


sub SimpleNetwork.SetVData (vd as string)
  mutexlock access_VData
    VData +=vd
  mutexunlock access_VData
end sub



function SimpleNetwork.GetMessage as string
  mutexlock access_VData
    function=VData
    VData=""
  mutexunlock access_VData
end function



sub SimpleNetwork.SendMessage(m as string,e as integer=1)
  dim as string et
  if e then et=EndTag else et=""
  TSNE_Data_Send(remote, m & et)
end sub



function SimpleNetwork.MessagePing as integer
  function=0
  mutexlock access_VData
    if right(VData,len(EndTag))=EndTag then function=1
  mutexunlock access_VData
end function



sub SimpleNetwork.SetConnectionStatus (c as integer)
  mutexlock access_status
    connected=c
  mutexunlock access_status
end sub



function SimpleNetwork.GetConnectionStatus as integer
  mutexlock access_status
    function=connected
  mutexunlock access_status
end function



function SimpleNetwork.CreateServer as integer
  function=0
  GuruCode = TSNE_Create_Server(Handle,Port, 1, @TSNE_NewConnection, @TSNE_NewConnectionCanceled)    'Server erstellen
  if GuruCode = TSNE_Const_NoError then
    SetStatusText "Server ready... "
    function=1
  else
    SetStatusText "Error: " & GuruCode
  end if
end function



function SimpleNetwork.CreateClient as integer
    function=0
   SetStatusText  "Searching Server... "
   GuruCode = TSNE_Create_Client(Handle, ServerIP ,Port, @TSNE_Disconnected, @TSNE_Connected, @TSNE_NewData,120) 'Client erstellen
    if GuruCode = TSNE_Const_NoError then
      function=1
    else
      SetStatusText  "Error: " & GuruCode
    endif
end function



sub SimpleNetwork.CloseSimpleNetwork
  TSNE_Disconnect(Handle)
  TSNE_WaitClose(Handle)
  mutexdestroy access_VData
  mutexdestroy access_status
end sub



dim shared as SimpleNetwork SN



'TSNE CallBacks****************************************************************
sub TSNE_Disconnected(byval V_TSNEID as uinteger)
  SN.SetConnectionStatus 0
  SN.SetStatusText(" +++ Disconnected +++ ")
end sub

sub TSNE_Connected(byval V_TSNEID as uinteger)
  SN.SetStatusText(" +++ Connected +++ ")
  SN.remote = V_TSNEID
  SN.SetConnectionStatus 1
end sub

sub TSNE_NewConnection(byval V_TSNEID as uinteger, byval V_RequestID as Socket, byval V_IPA as string)
  SN.SetStatusText("Client attempts to connect...")
  Dim XNeSNID as uinteger
  Dim XReturnIPA as string
  TSNE_Create_Accept(V_RequestID, XNeSNID, XReturnIPA, @TSNE_Disconnected, @TSNE_Connected, @TSNE_NewData)
end sub

sub TSNE_NewConnectionCanceled(byval V_TSNEID as uinteger, byval V_IPA as string)
  SN.SetStatusText("Connection refused")
end sub

sub TSNE_NewData(byval V_TSNEID as uinteger, byref V_Data as string)
  SN.SetVData (V_Data)
end sub

'/

'******************************************************************************
'******************************************************************************
'******************************************************************************
