#include once "SimpleGadget.bas"
#include once "StringGadget.bas"
#include once "ScrollBar.bas"
#include once "ListBox.bas"
#include once "Label.bas"
#include once "MessageBox.bas"

namespace sGUI

'InitGFX m u s s aufgerufen worden sein

declare function FileRequester(posx as integer,posy as integer,bt as string,path as string, file as string="",fmode as integer=0) as string
declare sub FindContent(gad as Gadget ptr,t as string )

function FileRequester(posx as integer,posy as integer,bt as string,path as string, file as string="",fmode as integer=0) as string
  function=""

  'save the origin background to restore it at end of dialog
  dim as integer ptr gfxbackup
  gfxbackup=imagecreate(400,300)
  get (posx,posy)-(posx+399,posy+299),gfxbackup

  'draw a fake window (directly in screen)
  FillA(posx,posy,400,300,0)
  FrameB(posx+2,posy+21,396,277,1)
  'ClearBox(posx+3,posy+22,394,275)
  'FillA(posx+2,posy+21,396,277,1)
  draw string (posx+5, posy+3),bt & "...",TextColor

  dim as string sep,drive,originpath=curdir
  'define the path separation
  #ifdef __fb_win32__
    sep="\"
  #endif
  'Tux Variante
  #ifdef __FB_LINUX__
    sep="/"
  #endif

  dim as integer rows
  if fontheight=8  then rows=22
  if fontheight=14 then rows=12
  if fontheight=16 then rows=11

  dim as string entry,GoToFolder,full
  GoToFolder=""
  entry=""
  chdir path
  path=curdir
  drive=left(path,1)

  'create a standard sGUI eventhandle
  dim as EventHandle ptr event
  event=CreateEventHandle

  'create all controls
  dim as Gadget ptr labelp,labelf,doit,cancel,strpath,strfile,contlist,cdparent

  labelp  =AddLabel(event,posx+5, posy+28,phrase_path & ":",TextColor)
  strpath =AddStringGadget(event,posx+52,posy+25,38,path,,1)
  contlist=AddListBox(event,posx+5,posy+54,46,rows)
  labelf  =AddLabel(event,posx+5, posy+245,phrase_file & ":",TextColor)
  strfile =AddStringGadget(event,posx+62,posy+242,29,file,,1)
  doit    =AddSimpleGadget(event,posx+309,posy+242,85,23,bt)
  cancel  =AddSimpleGadget(event,posx+309,posy+271,85,23,phrase_cancel)
  cdparent=AddSimpleGadget(event,posx+370,posy+25,24,23,"..")

  'fill the listbox with the content of the actual directory
  TO_ClearText(contlist)
  FindContent(contlist,"D")
  FindContent(contlist,"F")
  UpdateGadget(contlist)

  'switch all on
  GadgetOn(labelp,cdparent)

  'main event loop
  do
    event->xSleep(1,0)'dont check the window closebutton
    if event->GADGETMESSAGE then
      select case event->GADGETMESSAGE

        '
        case strpath                         'if user inputs a path
          chdir GetString(strpath)           'try to change the path, it can fail!
          path=curdir                        'get the actual path (now changed or not)

          TO_ClearText(contlist)             'fill listbox
          FindContent(contlist,"D")
          FindContent(contlist,"F")
          UpdateGadget(contlist)

          SetString(strpath,path)            'actualise path display

        case contlist'user select an entry in listbox
          entry=TO_GetLineContent(contlist,GetListBoxVal(contlist))'get string of entry

          if entry<>"" then
            if left(entry,6)="<DIR> " then       'if string starts with "<DIR> "   --> name of a directory
              GoToFolder=right(entry,len(entry)-6)
              chdir GoToFolder                   'change path
              path=curdir

              TO_ClearText(contlist)             'fill listbox
              FindContent(contlist,"D")
              FindContent(contlist,"F")
              UpdateGadget(contlist)

              SetString(strpath,path)            'actualise path display
            else                                 'if string starts not with "<DIR> " --> name of a file
              file=entry
              SetString(strfile,file)            'set file name display
            end if
          end if

        case cdparent'user change to parent directory
          'hmmm what comes now???
          chdir ".."
          path=curdir

          TO_ClearText(contlist)
          FindContent(contlist,"D")
          FindContent(contlist,"F")
          UpdateGadget(contlist)

          SetString(strpath,path)


        case strfile,doit'RETURN or the "DO IT" Button
          file=GetString(strfile)
          if file<>"" then
            if right(path,1)<> sep then
              full=path & sep & file
            else
              full=path & file
            end if
            if fmode then
              if fileexists(full) then
                function=full
                event->EXITEVENT=1
              else
                GadgetSleep(labelp,cdparent)
                MessageBox(posx+20,posy+100,phrase_fileaccessdenied,phrase_error,MBType_OK)
                RestoreActivation(labelp,cdparent)
              end if
            else
              function=full
              event->EXITEVENT=1
            end if
          end if

        'Abbruch des FileRequesters
        case cancel
          event->EXITEVENT=1
          function=""

      end select
    end if
  loop until event->EXITEVENT
  DestroyEventHandle(event)
  chdir originpath
  put (posx,posy),gfxbackup,pset
  imagedestroy gfxbackup
end function


sub FindContent(gad as Gadget ptr,t as string )
  dim as integer attr
  dim as string entryname,pre
  if ucase(t)="D" then 'bei "D" suche nach Verzeichnissen
    attr=&H10 + &H01
    pre="<DIR> "       '"Vorsilbe" um Verzeichnisse von Dateien unterscheiden zu knnen
  end if
  if ucase(t)="F" then  'bei "F" suche nach Dateien
    attr=&H00
    pre=""
  end if

  entryname=dir("*",attr)
  do
    if (len(entryname)>0) and (entryname<>".") and (entryname<>"..") then
      if TO_GetLineContent(gad,1)="" then
        TO_SetLineContent(gad,1,pre & entryname)
      else
        TO_AppendLine(gad,pre & entryname)
      end if
    end if
    entryname=dir
  loop while len(entryname)
end sub

end namespace
