'globale GFX Variablen
dim shared as integer contrast,fontheight,CustomColors,SleepShade
dim shared as uinteger BackGroundColor,GadgetColor,GadgetSelectedColor
dim shared as uinteger InnerGadgetCaptionColor,OuterGadgetCaptionColor,SymbolColor
dim shared as uinteger TextColor,EditTextColor,EditBackGroundColor,EditCursorColor
dim shared as uinteger MenuColor,MenuTextColor,MenuHiliteColor,MenuGhostedColor
const as uinteger black=&h000000,white=&hffffff

CustomColors=0
contrast=128'stellt tatschlich eine Art Kontrast-Variable dar
           'wer will,kann gerne mal mit rumspielen, es geht nichts kaputt :)
           'hab die 96 als angenehmsten empfunden

SleepShade=255*.6

declare function GetFontHeight as integer
declare sub InitGFX (clearscreen as integer=1)

declare function ShiftRGB (col as uinteger,shift as integer) as uinteger
declare function RGBAverage overload (cola as uinteger,colb as uinteger) as uinteger
declare function RGBAverage (cola as uinteger,colb as uinteger,colc as uinteger) as uinteger
declare sub ClearBox (xpos as integer,ypos as integer,fwidth as integer,fheight as integer,col as uinteger=BackGroundColor)
declare sub FillA (xpos as integer,ypos as integer,fwidth as integer,fheight as integer,switch as integer)
declare sub FillB (xpos as integer,ypos as integer,fwidth as integer,fheight as integer,col as uinteger)
declare sub FillC (xpos as integer,ypos as integer,fwidth as integer,fheight as integer,switch as integer)
declare sub FrameA (xpos as integer, ypos as integer, fwidth as integer, fheight as integer, topleft as uinteger,bottomright as uinteger, bcol as uinteger=BackGroundColor)
declare sub FrameB (xpos as integer, ypos as integer, fwidth as integer, fheight as integer,switch as integer)
declare sub FrameC (xpos as integer, ypos as integer)
declare sub FrameD (xpos as integer, ypos as integer, fwidth as integer, fheight as integer, col as uinteger,switch as integer)
declare sub FrameT (xpos as integer, ypos as integer, fwidth as integer, fheight as integer, txt as string="")
declare sub KnobShadow (xpos as integer, ypos as integer, fwidth as integer, fheight as integer,switch as integer)

declare sub CheckMark (xpos as integer,ypos as integer, col as uinteger)
declare sub Dot (xpos as integer,ypos as integer, col as uinteger)
declare sub Arrow (xpos as integer,ypos as integer,size as integer,d as integer,col as uinteger)
declare sub Slot (xpos as integer, ypos as integer, sl as integer,hv as integer)
declare sub Magnify (xpos as integer, ypos as integer,magsign as integer=1)

declare sub BarA (xpos as integer, ypos as integer, bwidth as integer, bheight as integer, col as uinteger)


sub InitGFX (clearscreen as integer=1)
	fontheight=GetFontHeight
	if CustomColors=0 then
    BackGroundColor         =&HD8D8E0'&HC8C8C8
    TextColor               =black
    GadgetColor			        =&HD8D8FF
    GadgetSelectedColor     =&HB7C0E0
    InnerGadgetCaptionColor =black
    OuterGadgetCaptionColor =black
    SymbolColor             =black
    EditTextColor           =black
    EditBackGroundColor     =&HF4F4F4
    EditCursorColor         =&H337FFF
    MenuColor               =BackGroundColor
    MenuTextColor           =black
    MenuHiliteColor         =GadgetColor'&H80D0FF
    MenuGhostedColor        =ShiftRGB (MenuColor,-contrast/2)
  end if

  if clearscreen then
    color TextColor,BackGroundColor
    cls
  end if
end sub



'nach einer Idee von Volta
'ermittelt die benutzte Fonthhe und gibt sie zurck
'siehe http://forum.qbasic.at/viewtopic.php?t=6065&highlight=fonth%F6he
function GetFontHeight as integer
  dim as integer h,fheight
  screeninfo ,h
  select case  h\hiword(width)
    case is < 8
      fheight=0
    case 8 to 13
      fheight=8
    case 14, 15
      fheight=14
    case is > 15
      fheight=16
  end select
  function=fheight
end function



'******************************************************************************
'******************************************************************************
'******************************************************************************
'es folgen alle Grafikelemente und Farbroutinen, die in irgend einer Weise in den Gadgets benutzt werden (knnen)
'also eine Art Grafik-Baukasten



'erhht/verringert die RGB Werte einer Farbe um den Wert shift
'eine einfache Additions/Subtraktionsvariante
function ShiftRGB (col as uinteger,shift as integer) as uinteger
  dim as integer red,green,blue
  'RGB Splitting
  'mal wieder Volta
  'siehe http://forum.qbasic.at/viewtopic.php?t=4274&highlight=rgb
  red  =((col shr 16) and &HFF)+shift
	green=((col shr 8) and &HFF )+shift
	blue =(col and &HFF         )+shift
	if red<0 then red=0
  if green<0 then green=0
  if blue<0 then blue=0
	if red>255 then red=255
  if green>255 then green=255
  if blue>255 then blue=255
  function=rgb(red,green,blue)
end function



function RGBAverage (cola as uinteger,colb as uinteger) as uinteger
  dim as integer reda,greena,bluea,redb,greenb,blueb
  reda  =((cola shr 16) and &HFF)
	greena=((cola shr 8) and &HFF )
	bluea =(cola and &HFF         )
  redb  =((colb shr 16) and &HFF)
	greenb=((colb shr 8) and &HFF )
	blueb =(colb and &HFF         )
  function=rgb((reda+redb)/2,(greena+greenb)/2,(bluea+blueb)/2)
end function



function RGBAverage (cola as uinteger,colb as uinteger,colc as uinteger) as uinteger
  dim as integer reda,greena,bluea,redb,greenb,blueb,redc,greenc,bluec
  reda  =((cola shr 16) and &HFF)
	greena=((cola shr 8) and &HFF )
	bluea =(cola and &HFF         )
  redb  =((colb shr 16) and &HFF)
	greenb=((colb shr 8) and &HFF )
	blueb =(colb and &HFF         )
  redc  =((colc shr 16) and &HFF)
	greenc=((colc shr 8) and &HFF )
	bluec =(colc and &HFF         )
  function=rgb((reda+redb+redc)/3,(greena+greenb+greenc)/3,(bluea+blueb+bluec)/3)
end function



'von allen Gadgets als Reinigungsdienst benutzt
sub ClearBox (xpos as integer,ypos as integer,fwidth as integer,fheight as integer,col as uinteger=BackGroundColor)
	line (xpos,ypos)-(xpos+fwidth-1,ypos+fheight-1),col,BF
end sub



Sub FillA (xpos as integer,ypos as integer,fwidth as integer,fheight as integer,switch as integer)
  dim as integer offset,iwidth,iheight
  dim as uinteger cola,colb,corner,topleft,bottomright
	dim as single shiftstp,tmpshift,oko
  if switch then
    oko=.4
    cola=ShiftRGB(GadgetSelectedColor,4)
    colb=GadgetSelectedColor
    topleft=ShiftRGB(cola,-contrast/4)
    bottomright=ShiftRGB(cola,-contrast/2)
    corner=bottomright
  else
    oko=.5
    cola=ShiftRGB(GadgetColor,4)
    colb=GadgetColor
    topleft=ShiftRGB(cola,+contrast/2)
    bottomright=ShiftRGB(cola,-contrast/2)
    corner=cola
  end if

  iwidth=fwidth-2
  iheight=fheight-2
  if iheight<=iwidth then
    offset=iheight *  oko
    shiftstp=(contrast/4)/iheight
  else
    offset=iwidth *  oko
    shiftstp=(contrast/4)/iwidth
  end if

  if iheight<=iwidth then
    tmpshift=0
    for i as integer=0 to offset-1
      line(xpos+1,ypos+1+i)-(xpos+iwidth,ypos+1+i ),ShiftRGB(cola,int(tmpshift))
      tmpshift +=shiftstp
    next i
    tmpshift=0
    for i as integer=0 to iheight-offset-1
      line(xpos+1,ypos+offset+1+i)-(xpos+iwidth,ypos+offset+1+i),ShiftRGB(colb,int(tmpshift))
      tmpshift +=shiftstp
    next i
  else
    tmpshift=0
    for i as integer=0 to offset-1
      line(xpos+1+i,ypos+1)-(xpos+1+i,ypos+iheight ),ShiftRGB(cola,int(tmpshift))
      tmpshift +=shiftstp
    next i
    tmpshift=0
    for i as integer=0 to iwidth-offset-1
      line(xpos+offset+1+i,ypos+1)-(xpos+offset+1+i,ypos+iheight),ShiftRGB(colb,int(tmpshift))
      tmpshift +=shiftstp
    next i
  end if

  FrameA(xpos,ypos,fwidth,fheight,topleft,bottomright)
end sub



Sub FillB (xpos as integer,ypos as integer,fwidth as integer,fheight as integer,col as uinteger)
  dim as uinteger topleft,bottomright
  topleft=ShiftRGB(col,-contrast/8)
  bottomright=ShiftRGB(col,+contrast/8)
  line (xpos+1,ypos+1)-(xpos+fwidth-2,ypos+fheight-2),col,BF
  FrameA(xpos,ypos,fwidth,fheight,topleft,bottomright)
end sub


'farbiger Rahmen, ungefllt
sub FrameA (xpos as integer, ypos as integer, fwidth as integer, fheight as integer, topleft as uinteger,bottomright as uinteger, bcol as uinteger=BackGroundColor)
  line (xpos+1,ypos)-(xpos+fwidth-2,ypos),topleft
  line (xpos+fwidth-1,ypos+1)-(xpos+fwidth-1,ypos+fheight-2),bottomright
  line (xpos+fwidth-2,ypos+fheight-1)-(xpos+1,ypos+fheight-1),bottomright
  line (xpos,ypos+fheight-2)-(xpos,ypos+1),topleft
/'
  line (xpos,ypos+1)-(xpos+1,ypos),topleft
  line (xpos+fwidth-2,ypos)-(xpos+fwidth-1,ypos+1),RGBAverage(topleft,bottomright)
  line (xpos+fwidth-1,ypos+fheight-2)-(xpos+fwidth-2,ypos+fheight-1),bottomright
  line (xpos+1,ypos+fheight-1)-(xpos,ypos+fheight-2),topleft

  pset (xpos,ypos),RGBAverage(topleft,bcol,bcol)
  pset (xpos+fwidth-1,ypos),RGBAverage(topleft,bottomright,bcol)
  pset (xpos+fwidth-1,ypos+fheight-1),RGBAverage(bottomright,bcol,bcol)
  pset (xpos,ypos+fheight-1),RGBAverage(topleft,bottomright,bcol)
'/
  pset (xpos+1,ypos+1),topleft

  pset (xpos+fwidth-2,ypos),RGBAverage(topleft,bottomright,bcol)
    pset (xpos+fwidth-2,ypos+1),RGBAverage(topleft,bottomright,bcol)
  pset (xpos+fwidth-1,ypos+1),RGBAverage(topleft,bottomright,bcol)

  pset (xpos+fwidth-2,ypos+fheight-2),bottomright

  pset (xpos+1,ypos+fheight-1),RGBAverage(topleft,bottomright,bcol)
    pset (xpos+1,ypos+fheight-2),RGBAverage(topleft,bottomright,bcol)
  pset (xpos,ypos+fheight-2),RGBAverage(topleft,bottomright,bcol)
end sub



'Rahmen(hintergrundbezogen) in zwei Schaltzustnden, ungefllt
'SimpleGadget,ToggleGadget,CheckmarkGadget
sub FrameB (xpos as integer, ypos as integer, fwidth as integer, fheight as integer,switch as integer)
	dim as uinteger topleft,bottomright,corner

  'Farben fr Hintergrundfase berechnen
  topleft=ShiftRGB(BackGroundColor,-contrast)
  corner=BackGroundColor
  if switch then
    bottomright=ShiftRGB(BackGroundColor,contrast/2)
  else
    bottomright=topleft
  	corner=topleft
	end if

  FrameA (xpos,ypos,fwidth,fheight,topleft,bottomright)
end sub



'Rahmen(hintergrundbezogen), gefllt
'Radiobutton  12x12 px
sub FrameC (xpos as integer, ypos as integer)
	dim as uinteger toplefta,topleftb,bottomrighta,bottomrightb,body

  'Farben fr Hintergrundfase berechnen
  toplefta=ShiftRGB(BackGroundColor,-contrast)
  topleftb=ShiftRGB(BackGroundColor,-contrast/5)
  bottomrighta=ShiftRGB(BackGroundColor,contrast/3)
  bottomrightb=ShiftRGB(BackGroundColor,contrast/7)
  body=BackGroundColor


	line(xpos+3,ypos)-(xpos+8,ypos),toplefta
	pset(xpos+9,ypos+1),topleftb
	pset(xpos+10,ypos+2),bottomrightb
  line(xpos+11,ypos+3)-(xpos+11,ypos+8),bottomrighta
  line(xpos+10,ypos+9)-(xpos+9,ypos+10),bottomrighta
  line(xpos+8,ypos+11)-(xpos+3,ypos+11),bottomrightb
	pset(xpos+2,ypos+10),bottomrightb
	pset(xpos+1,ypos+9),topleftb
  line(xpos,ypos+8)-(xpos,ypos+3),toplefta
  line(xpos+1,ypos+2)-(xpos+2,ypos+1),toplefta
end sub



'farbiger Rahmen in zwei Schaltzustnden
'StringGadget
sub FrameD (xpos as integer, ypos as integer, fwidth as integer, fheight as integer, col as uinteger,switch as integer)
	dim as uinteger topleft,bottomright
	topleft=ShiftRGB(col,contrast/2)
  bottomright=ShiftRGB(col,-contrast/2)
	if switch then swap topleft,bottomright
  line (xpos,ypos)-(xpos+fwidth-2,ypos),topleft
  pset (xpos+fwidth-1,ypos),col
  line (xpos+fwidth-1,ypos+1)-(xpos+fwidth-1,ypos+fheight-1),bottomright
  line (xpos+fwidth-2,ypos+fheight-1)-(xpos+1,ypos+fheight-1),bottomright
  pset (xpos,ypos+fheight-1),col
  line (xpos,ypos+fheight-2)-(xpos,ypos),topleft
end sub



'Rahmen (hintergrundbezogen) mit Text, gefllt, fr Gliederung der Oberflche
sub FrameT (xpos as integer, ypos as integer, fwidth as integer, fheight as integer, txt as string="")
	dim as uinteger lite,dark

	'Farben fr Hintergrundfase berechnen
  lite=ShiftRGB(BackGroundColor,contrast)'RGBwerte anheben
  dark=ShiftRGB(BackGroundColor,-contrast)'RGBwerte absenken

	line (xpos+1,ypos+1)-(xpos+fwidth-1,ypos+fheight-1),lite,b
  line (xpos,ypos)-(xpos+fwidth-2,ypos+fheight-2),dark,b
  line (xpos+2,ypos+2)-(xpos+fwidth-3,ypos+fheight-3),BackGroundColor,bf 'Lschen des Frameinneren

	if len(txt) then
    line(xpos+8,ypos-fontheight/2)-(xpos+8+8*len(txt),ypos-fontheight/2+fontheight),BackGroundColor,bf
    draw string (xpos+8,ypos-fontheight/2),txt,TextColor
  end if
end sub



'Schatten fr knob im Scrollbar
sub KnobShadow (xpos as integer, ypos as integer, fwidth as integer, fheight as integer,switch as integer)
	fwidth +=1
	fheight +=1
  dim as uinteger bottomright=ShiftRGB(BackGroundColor,-contrast)
  if switch=0 then
    line (xpos+fwidth-1,ypos+2)-(xpos+fwidth-1,ypos+fheight-2),bottomright
    line (xpos+fwidth-2,ypos+fheight-1)-(xpos+2,ypos+fheight-1),bottomright

      pset (xpos+fwidth-2,ypos+1),RGBAverage(bottomright,bottomright,BackGroundColor)
    pset (xpos+fwidth-1,ypos+1),RGBAverage(bottomright,bottomright,BackGroundColor)

    pset (xpos+fwidth-2,ypos+fheight-2),bottomright
    
      pset (xpos+1,ypos+fheight-1),RGBAverage(bottomright,bottomright,BackGroundColor)
    pset (xpos+1,ypos+fheight-2),RGBAverage(bottomright,bottomright,BackGroundColor)
	end if
end sub



'farbiges Symbol
'"Hkchen" fr CheckMarkGadget 8x8 px
sub CheckMark (xpos as integer,ypos as integer, col as uinteger)
  line(xpos+1,ypos+4)-(xpos+4,ypos+7),col
  line(xpos,ypos+4)-(xpos+3,ypos+7),col

  line(xpos+4,ypos+7)-(xpos+7,ypos),col
  line(xpos+3,ypos+7)-(xpos+6,ypos),col
end sub



'farbiges Symbol
'RadiobuttonDot  8x8 px
sub Dot (xpos as integer,ypos as integer, col as uinteger)
  dim as uinteger topleft,bottomright

	topleft=ShiftRGB(col,contrast/2)
  bottomright=ShiftRGB(col,-contrast/2)

	line(xpos+2,ypos)-(xpos+5,ypos),topleft
  pset(xpos+6,ypos+1),col
  line(xpos+7,ypos+2)-(xpos+7,ypos+5),bottomright
  pset(xpos+6,ypos+6),bottomright
  line(xpos+5,ypos+7)-(xpos+2,ypos+7),bottomright
	pset(xpos+1,ypos+6),col
  line(xpos,ypos+5)-(xpos,ypos+2),topleft
  pset(xpos+1,ypos+1),topleft


  line(xpos+1,ypos+2)-(xpos+2,ypos+1),ShiftRGB(col,contrast*2)
  line(xpos+1,ypos+3)-(xpos+3,ypos+1),ShiftRGB(col,contrast)
  line(xpos+1,ypos+4)-(xpos+4,ypos+1),ShiftRGB(col,contrast/2)
  line(xpos+1,ypos+5)-(xpos+5,ypos+1),ShiftRGB(col,contrast/4)

  line(xpos+2,ypos+5)-(xpos+5,ypos+2),col

  line(xpos+2,ypos+6)-(xpos+6,ypos+2),ShiftRGB(col,-contrast/4)
  line(xpos+3,ypos+6)-(xpos+6,ypos+3),ShiftRGB(col,-contrast/2)
  line(xpos+4,ypos+6)-(xpos+6,ypos+4),ShiftRGB(col,-contrast/1.5)
  line(xpos+5,ypos+6)-(xpos+6,ypos+5),ShiftRGB(col,-contrast)
end sub



'farbiges Symbol
'Pfeil
sub Arrow (xpos as integer,ypos as integer,size as integer,d as integer,col as uinteger)
  dim as integer i
  for i=0 to size
    if d=0 then line(xpos+size-i,ypos+i)-(xpos+size-i,ypos+2*size-i),col
    if d=1 then line(xpos+i,ypos+i)-(xpos+i,ypos+2*size-i),col
    if d=2 then line(xpos+i,ypos+size-i)-(xpos+2*size-i,ypos+size-i),col
    if d=3 then line(xpos+i,ypos+i)-(xpos+2*size-i,ypos+i),col
  next i
end sub



'Lupensymbol 11*11
sub Magnify (xpos as integer, ypos as integer,magsign as integer=1)
  line(xpos+2,ypos)-(xpos+6,ypos),black,bf
  pset(xpos+7,ypos+1),black
  line(xpos+8,ypos+2)-(xpos+8,ypos+6),black,bf
  'pset(xpos+7,ypos+7),black
  line(xpos+6,ypos+8)-(xpos+2,ypos+8),black,bf
  pset(xpos+1,ypos+7),black
  line(xpos,ypos+6)-(xpos,ypos+2),black,bf
  pset(xpos+1,ypos+1),black

  line(xpos+8,ypos+7)-(xpos+10,ypos+9),black
  line(xpos+7,ypos+7)-(xpos+10,ypos+10),black
  line(xpos+7,ypos+8)-(xpos+9,ypos+10),black

  line(xpos+2,ypos+4)-(xpos+6,ypos+4),black
  if magsign then line(xpos+4,ypos+2)-(xpos+4,ypos+6),black
end sub



'Slot
'Trackbar hv 0=horizontal 1=vertikal
sub Slot (xpos as integer, ypos as integer, sl as integer,hv as integer)
	dim as integer topleft,bottomright

  topleft=ShiftRGB(BackGroundColor,-contrast)
  bottomright=ShiftRGB(BackGroundColor,contrast/2)
  if hv then
    if sl>=1 then
      line(xpos,ypos)-(xpos,ypos+sl-1),topleft
      line(xpos+1,ypos)-(xpos+1,ypos+sl-1),bottomright
    end if
  else
    if sl>=1 then
      line(xpos,ypos)-(xpos+sl-1,ypos),topleft
      line(xpos,ypos+1)-(xpos+sl-1,ypos+1),bottomright
    end if
  end if
end sub



sub BarA (xpos as integer,ypos as integer,bwidth as integer,bheight as integer,col as uinteger)
  dim as integer k
	dim as single shiftstp,tmpshift
  shiftstp=(contrast/2)/(bheight-2)
  tmpshift=contrast/4

  line(xpos,ypos)-(xpos+bwidth-1,ypos),ShiftRGB(col,contrast/2)
  for k=0 to bheight-3
    line(xpos,ypos+1+k)-(xpos+bwidth-1,ypos+1+k),ShiftRGB(col,int(tmpshift))
    tmpshift -=shiftstp
  next k
  line(xpos,ypos+bheight-1)-(xpos+bwidth-1,ypos+bheight-1),ShiftRGB(col,-contrast/2)
end sub

